{
  - Do not confuse battle status and battle state!
  - If you change any of the tab sheet captions, make sure any sentences like
    "if PageControl1.ActivePage.Caption = 'Player control then ...'" gets
    updated too!

}

unit BattleFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, janTracker, Buttons, Unit1, jpeg,
  VirtualTrees, Menus;

type
  TBattleForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ChatRichEdit: TRichEdit;
    InputEdit: TEdit;
    SizeLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel3: TPanel;
    StartButton: TButton;
    HostButton: TButton;
    DisconnectButton: TButton;
    Label13: TLabel;
    ClientsListBox: TListBox;
    Label14: TLabel;
    GameTimer: TTimer;
    NoMapImage: TImage;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ResourcesGroupBox: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EnergyTracker: TjanTracker;
    MetalTracker: TjanTracker;
    UnitsTracker: TjanTracker;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    GameEndRadioGroup: TRadioGroup;
    StartPosRadioGroup: TRadioGroup;
    MyOptionsGroupBox: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    TeamComboBox: TComboBox;
    AllyComboBox: TComboBox;
    SideLabel: TLabel;
    SideComboBox: TComboBox;
    ReadyCheckBox: TCheckBox;
    SpectateCheckBox: TCheckBox;
    Label16: TLabel;
    Label17: TLabel;
    MapDescLabel: TLabel;
    TeamColorSpeedButton: TSpeedButton;
    PlayerControlGroupBox: TGroupBox;
    HandicapTracker: TjanTracker;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Label18: TLabel;
    Label19: TLabel;
    ForceTeamComboBox: TComboBox;
    ForceAllyComboBox: TComboBox;
    UnitsGroupBox: TGroupBox;
    DisabledUnitsListBox: TListBox;
    AddUnitsSpeedButton: TSpeedButton;
    PopupMenu1: TPopupMenu;
    Item1: TMenuItem;
    MapPanel: TPanel;
    MapList: TListBox;
    MapImage: TImage;

    function IsBattleActive: Boolean;
    procedure AddTextToChat(Text: string; Color: TColor);
    procedure UpdateClientsListBox;
    function GetMyBattleStatus: Integer;
    procedure SetMyBattleStatus(Side: Integer; Ready: Boolean; TeamNo: Integer; AllyNo: Integer; Mode: Integer; TeamColor: Integer);
    procedure SendMyBattleStatusToServer;
    procedure SendBattleDetailsToServer;
    procedure PopulateMapList;
    procedure GenerateScriptFile(FileName: string);

    procedure ChangeTeamColor(ColorIndex: Integer; UpdateServer: Boolean);

    procedure FigureOutBestPossibleTeamAllyAndColor;
    procedure ChangeCurrentMod(ModName: string);

    procedure ResetBattleScreen;
    function JoinBattle(BattleID: Integer): Boolean;
    function HostBattle(BattleID: Integer): Boolean;
    procedure ChangeMapToNoMap(MapName: string);

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MapListClick(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure HostButtonClick(Sender: TObject);
    procedure Label13Click(Sender: TObject);
    procedure MapImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure ReadyCheckBoxClick(Sender: TObject);
    procedure SideComboBoxChange(Sender: TObject);
    procedure TeamComboBoxChange(Sender: TObject);
    procedure AllyComboBoxChange(Sender: TObject);
    procedure SideComboBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SideLabelClick(Sender: TObject);
    procedure MetalTrackerMouseUpAfterChange(Sender: TObject);
    procedure EnergyTrackerMouseUpAfterChange(Sender: TObject);
    procedure UnitsTrackerMouseUpAfterChange(Sender: TObject);
    procedure StartPosRadioGroupClick(Sender: TObject);
    procedure ClientsListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure GameTimerTimer(Sender: TObject);
    procedure InputEditKeyPress(Sender: TObject; var Key: Char);
    procedure InputEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpectateCheckBoxClick(Sender: TObject);
    procedure ClientsListBoxDblClick(Sender: TObject);
    procedure GameEndRadioGroupClick(Sender: TObject);
    procedure HandicapTrackerMouseUpAfterChange(Sender: TObject);
    procedure ClientsListBoxClick(Sender: TObject);
    procedure TeamColorSpeedButtonClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ForceTeamComboBoxClick(Sender: TObject);
    procedure ForceAllyComboBoxClick(Sender: TObject);
    procedure AddUnitsSpeedButtonClick(Sender: TObject);
    procedure Item1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TBattleParticipation = (None, Hosting, Joined);
  // use Hosting if you are the host of the battle and server has already
  // updated/approved your battle. Use Joined if you are connected to someone
  // else's battle. Use None if none of the above is true.


var
  BattleForm: TBattleForm;

  BattleState:
  record
    Status: TBattleParticipation;
    Battle: TBattle; // don't ever free this object! It is freed automatically by RemoveBattle method! This object is only "pointer" to an item in Battles list!
    Process: // we need this information when we launch game exe
    record
      proc_info: TProcessInformation;
      startinfo: TStartupInfo;
      ExitCode: LongWord;
    end;
  end;

  AllowBattleStatusUpdate: Boolean = True;
  { should be always true except when we are changing some checkbox's checked status or TRadioGroup's ItemIndex property. The problem
    is, that the sentence "MyCheckBox.Checked := True" will trigger OnClick event, but only if value changed. Also, TRadioGroup works
    the same way (ItemIndex). But changing TComboBox's ItemIndex will not trigger OnChange event! }

implementation

uses
  Utility, Misc, HostBattleFormUnit, ShellAPI,
  MinimapZoomedFormUnit, PreferencesFormUnit, ChooseColorFormUnit,
  DisableUnitsFormUnit, InitWaitFormUnit;

{$R *.dfm}

{ returns True if battle is active, that is if we are hosting a battle or if
  we are connected to someone else's battle }
function TBattleForm.IsBattleActive: Boolean;
begin
  Result := (BattleState.Status = Hosting) or (BattleState.Status = Joined);
end;

procedure TBattleForm.AddTextToChat(Text: string; Color: TColor);
begin
  if Preferences.TimeStamps then Text := '[' + TimeToStr(Now) + '] ' + Text;
  Misc.AddTextToRichEdit(ChatRichEdit, Text, Color);
end;

procedure TBattleForm.UpdateClientsListBox;
var
  tmpItemIndex: Integer;
begin
  tmpItemIndex := ClientsListBox.ItemIndex;

  if BattleState.Status = None then
    ClientsListBox.Items.SetText(PChar(''))
  else
    ClientsListBox.Items.SetText(PChar(CreateStrings(BattleState.Battle.Clients.Count)));

  if ClientsListBox.ItemIndex = -1 then // this should actually ALWAYS be true since ItemIndex should change to -1 when Items change
    if PageControl1.ActivePage.Caption = 'Player control' then
    begin
      if tmpItemIndex > ClientsListBox.Count-1 then
        DisableControlAndChildren(PlayerControlGroupBox)
      else
        ClientsListBox.ItemIndex := tmpItemIndex;
    end
    else
      DisableControlAndChildren(PlayerControlGroupBox);
end;

function TBattleForm.GetMyBattleStatus: Integer;
begin
  // see protocol's description for more info on battle status value!

  Result := 0;

  // side:
  Inc(Result, SideComboBox.ItemIndex);

  // ready:
  Inc(Result, BoolToInt(ReadyCheckBox.Checked) shl 1);

  // team no.:
  Inc(Result, TeamComboBox.ItemIndex shl 2);

  // ally no.:
  Inc(Result, AllyComboBox.ItemIndex shl 6);

  // mode:
  Inc(Result, BoolToInt(not SpectateCheckBox.Checked) shl 10);

  // handicap is ignored (only host can change it)

  // team color index:
  Inc(Result, TeamColorIndex shl 18);

  // sync status:
  Inc(Result, (2-BoolToInt(Status.Synced)) shl 22);

end;

procedure TBattleForm.SetMyBattleStatus(Side: Integer; Ready: Boolean; TeamNo: Integer; AllyNo: Integer; Mode: Integer; TeamColor: Integer);
begin
  AllowBattleStatusUpdate := False;

  // handicap is ignored (only host can change it)
  SideComboBox.ItemIndex := Side;
  ReadyCheckBox.Checked := Ready;
  TeamComboBox.ItemIndex := TeamNo;
  AllyComboBox.ItemIndex := AllyNo;
  SpectateCheckBox.Checked := not IntToBool(Mode);
  ChangeTeamColor(TeamColor, False);

  AllowBattleStatusUpdate := True;
end;

{ updates the battle status only if AllowBattleStatusUpdate = True }
procedure TBattleForm.SendMyBattleStatusToServer;
begin
  if not IsBattleActive then Exit; // we are not allowed to call it if we are not participating in a battle

  if not AllowBattleStatusUpdate then Exit;

  MainForm.TryToSendData('MYBATTLESTATUS ' + IntToStr(GetMyBattleStatus));
end;

procedure TBattleForm.SendBattleDetailsToServer; // call it each time you update some of the parameters of the battle (except for map name, which is a "battle info" parameter)
begin
  if not (BattleState.Status = Hosting) then Exit; // this should not happen though

  MainForm.TryToSendData('UPDATEBATTLEDETAILS ' + IntToStr(MetalTracker.Value) + ' ' + IntToStr(EnergyTracker.Value) + ' ' + IntToStr(UnitsTracker.Value) + ' ' +IntToStr(StartPosRadioGroup.ItemIndex) + ' ' +IntToStr(GameEndRadioGroup.ItemIndex));
end;

{ tries to figure out best possible team number, ally number and team color. It tries to use those numbers that aren't used
  by other players in the battle. NOTE: you shouldn't call this method before you received all battle statuses of the players
  in battle! That is why you should call it when you receive REQUESTBATTLESTATUS and not before! }
procedure TBattleForm.FigureOutBestPossibleTeamAllyAndColor;
var
  i: Integer;
  team, ally, color: Integer;
  found: Boolean;
begin
  if not IsBattleActive then Exit; // should not happen!

  // find first available team and ally:
  team := 0;
  found := False;
  while not Found do
  begin
    Found := True;
    for i := 0 to BattleState.Battle.Clients.Count - 1 do
      if TClient(BattleState.Battle.Clients[i]).Name <> Status.Username then
        if TClient(BattleState.Battle.Clients[i]).GetMode <> 0 then
          if TClient(BattleState.Battle.Clients[i]).GetTeamNo = team then
          begin
            Inc(team);
            Found := False;
            Break;
          end;
  end;
  ally := team;

  // find first available team color:
  color := 0;
  found := False;
  while not Found do
  begin
    Found := True;
    for i := 0 to BattleState.Battle.Clients.Count-1 do
      if TClient(BattleState.Battle.Clients[i]).Name <> Status.Username then
        if TClient(BattleState.Battle.Clients[i]).GetMode <> 0 then
          if TClient(BattleState.Battle.Clients[i]).GetTeamColor = color then
          begin
            Inc(color);
            Found := False;
            Break;
          end;
  end;
  if color > 9 then color := 0;

  SetMyBattleStatus(SideComboBox.ItemIndex, False, team, ally, 1, color);
end;

procedure TBattleForm.ChangeCurrentMod(ModName: string);
var
  tmp: Integer;
  tmpBool: Boolean;

begin

  tmp := ModList.Count;
  ReInitLib; // will automatically update mod list
  tmpBool := tmp <> ModList.Count; // did number of mods change?
  // update mod list:
  if tmpBool then
    HostBattleForm.ModsComboBox.Items.Assign(Utility.ModList);

  LoadMod(ModArchiveList[ModList.IndexOf(ModName)]);
end;

function TBattleForm.JoinBattle(BattleID: Integer): Boolean;
var
  Battle: TBattle;
  index: Integer;
  tmp: Integer;

begin
  Result := False;

  if BattleState.Status <> None then
  begin // this should NEVER happen!
    MessageDlg('Error: cannot participate in multiple battles. Please report this error!', mtError, [mbOK], 0);
    Application.Terminate;
    Exit;
  end;

  Battle := MainForm.GetBattle(BattleID);
  if Battle = nil then Exit;

  BattleState.Battle := Battle;

  DisabledUnitsListBox.Clear;

  MapList.Enabled := False;
  StartPosRadioGroup.Enabled := False;
  GameEndRadioGroup.Enabled := False;
  DisableControlAndChildren(ResourcesGroupBox);
  EnableControlAndChildren(MyOptionsGroupBox);
  DisableControlAndChildren(UnitsGroupBox);

//  SetMyBattleStatus(SideComboBox.ItemIndex, False, 0, 0, 1, TeamColorIndex); *** we will update it once we receive REQUESTBATTLESTATUS
  // we will send our battle status to server as soon as we receive REQUESTBATTLESTATUS (server should send it after he is finished sending us battle statuses of other players)

  UpdateClientsListBox;

  // update map:
  index := MapList.Items.IndexOf(Battle.Map);
  if index = -1 then ChangeMapToNoMap(Battle.Map)
  else
  begin
    tmp := BattleForm.MapList.ItemIndex;
    MapList.ItemIndex := index;
    if tmp <> index then
      MapList.OnClick(nil); // we MUST send nil as parameter, since the event checks if Sender is nil and that way he knows whether user clicked on map list or not
  end;

  DisconnectButton.Enabled := True;
  StartButton.Enabled := False;
  HostButton.Enabled := False;

  AddTextToChat('Joined battle', Colors.Info);

  BattleState.Status := Joined;

  Result := True;

  PlayResSound('battle');

//*** anything else?
end;

function TBattleForm.HostBattle(BattleID: Integer): Boolean;
var
  Battle: TBattle;
begin
  Result := False;

  if IsBattleActive then
  begin // this should NEVER happen!
    MessageDlg('Error: cannot participate in multiple battles. Please report this error!', mtError, [mbOK], 0);
    Application.Terminate;
    Exit;
  end;

  Battle := MainForm.GetBattle(BattleID);
  if Battle = nil then Exit;

  BattleState.Battle := Battle;

  DisabledUnitsListBox.Clear;

  MapList.Enabled := True;
  StartPosRadioGroup.Enabled := True;
  GameEndRadioGroup.Enabled := True;
  EnableControlAndChildren(ResourcesGroupBox);
  EnableControlAndChildren(MyOptionsGroupBox);
  EnableControlAndChildren(UnitsGroupBox);

  SetMyBattleStatus(SideComboBox.ItemIndex, False, 0, 0, 1, TeamColorIndex);
  // we will send our battle status to server as soon as we receive REQUESTBATTLESTATUS (server should send it after he is finished sending us battle statuses of other players)

  UpdateClientsListBox;

  DisconnectButton.Enabled := True;
  StartButton.Enabled := False;
  HostButton.Enabled := False;

  AddTextToChat('Battle opened', Colors.Info);

  BattleState.Status := Hosting;

  Result := True;

  PlayResSound('battle');

//*** anything else?
end;


{ resets the battle screen: clears the clients list, enables/disables controls, ... }
procedure TBattleForm.ResetBattleScreen;
begin
  if IsBattleActive then
  begin
    AddTextToChat('Battle closed', Colors.Info);
    PlayResSound('battle');
  end;

  BattleState.Status := None;

  DisabledUnitsListBox.Clear;

  MapList.Enabled := True;
  StartPosRadioGroup.Enabled := False;
  GameEndRadioGroup.Enabled := False;
  DisableControlAndChildren(PlayerControlGroupBox);
  DisableControlAndChildren(ResourcesGroupBox);
  DisableControlAndChildren(MyOptionsGroupBox);
  DisableControlAndChildren(UnitsGroupBox);

  SetMyBattleStatus(SideComboBox.ItemIndex, False, 0, 0, 1, TeamColorIndex);

  UpdateClientsListBox;

  DisconnectButton.Enabled := False;
  StartButton.Enabled := False;
  HostButton.Enabled := True;

//*** anything else?
end;

procedure TBattleForm.ChangeMapToNoMap(MapName: string);
begin
  MapName := Copy(MapName, 1, Length(MapName)-4); // remove '.smf'
  MapImage.Picture.Bitmap.Assign(NoMapImage.Picture.Bitmap);
  with MapImage.Picture.Bitmap.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Style := Font.Style + [fsBold];
    Font.Size := 16; // default
    while TextWidth(MapName) > MapImage.Picture.Bitmap.Width do
    begin
      Font.Size := Font.Size - 1;
      if Font.Size = 1 then Break; // smallest possible size
    end;

    Font.Color := $001111EE; // (0, B, G, R)
    TextOut(MapImage.Picture.Bitmap.Width div 2 - TextWidth(MapName) div 2, MapImage.Picture.Bitmap.Height div 2 - TextHeight('X') div 2, MapName);

    Font.Size := 11;
    Font.Color := clBlack;
    TextOut(5, 5, 'Map not found:');
  end;
  MapList.ItemIndex := -1;
  Exit;
end;

procedure TBattleForm.PopulateMapList;
begin
  Utility.GetMapList(MapList.Items);
end;

procedure TBattleForm.GenerateScriptFile(FileName: string);
var
  f: TextFile;
  NumberOfTeams: Integer;
  NumberOfAllyTeams: Integer;
  i, j: Integer;
  Pos: Integer;
  ModFileName: string;

  PurgedClients: array of // without spectators and with shiftet team and ally numbers
  record
    ClientIndex: Integer;
    TeamNo: Integer;
    AllyNo: Integer;
    TeamColor: Integer;
    Side: Integer; // 0 = Arm, 1 = Core
    Handicap: Integer;
  end;

  TeamToPurgedTeam: array[0..15] of Integer; // TeamToPurgedTeam[IndexOfTeam]: IndexOfPurgedTeam
  AllyToPurgedAlly: array[0..15] of Integer; // AllyToPurgedAlly[IndexOfAllyTeam]: IndexOfPurgedAllyTeam

  // "purging" is needed for one reason: there mustn't be any gaps between team/ally numbers

begin
  // get mod archive name:
  i := ModList.IndexOf(BattleState.Battle.ModName);
  if i = -1 then
  begin
    MessageDlg('Error: mod not found (' + BattleState.Battle.ModName + ')', mtError, [mbOK], 0);
    Application.Terminate;
    Exit;
  end;
  ModFileName := ModArchiveList[i];

  // do the "purging":

  NumberOfTeams := 0;
  for i := 0 to High(TeamToPurgedTeam) do TeamToPurgedTeam[i] := -1;
  for i := 0 to BattleState.Battle.Clients.Count-1 do if TClient(BattleState.Battle.Clients[i]).GetMode = 1 then if TeamToPurgedTeam[TClient(BattleState.Battle.Clients[i]).GetTeamNo] = -1 then
  begin
    TeamToPurgedTeam[TClient(BattleState.Battle.Clients[i]).GetTeamNo] := NumberOfTeams;
    Inc(NumberOfTeams);
  end;

  NumberOfAllyTeams := 0;
  for i := 0 to High(AllyToPurgedAlly) do AllyToPurgedAlly[i] := -1;
  for i := 0 to BattleState.Battle.Clients.Count-1 do if TClient(BattleState.Battle.Clients[i]).GetMode = 1 then if AllyToPurgedAlly[TClient(BattleState.Battle.Clients[i]).GetAllyNo] = -1 then
  begin
    AllyToPurgedAlly[TClient(BattleState.Battle.Clients[i]).GetAllyNo] := NumberOfAllyTeams;
    Inc(NumberOfAllyTeams);
  end;

  SetLength(PurgedClients, BattleState.Battle.Clients.Count - BattleState.Battle.SpectatorCount);
  for i := 0 to BattleState.Battle.Clients.Count-1 do if TClient(BattleState.Battle.Clients[i]).GetMode = 1 then
  begin
    PurgedClients[i].ClientIndex := i;
    PurgedClients[i].TeamNo := TeamToPurgedTeam[TClient(BattleState.Battle.Clients[i]).GetTeamNo];
    PurgedClients[i].AllyNo := AllyToPurgedAlly[TClient(BattleState.Battle.Clients[i]).GetAllyNo];
    PurgedClients[i].TeamColor := TClient(BattleState.Battle.Clients[i]).GetTeamColor;
    PurgedClients[i].Side := TClient(BattleState.Battle.Clients[i]).GetSide;
    PurgedClients[i].Handicap := TClient(BattleState.Battle.Clients[i]).GetHandicap;
  end;

  // now let's write the script file:

  AssignFile(f, FileName);
  Rewrite(f);
  Writeln(f, '[GAME]');
  Writeln(f, '{');
  Writeln(f, #9 + 'Mapname=' + BattleState.Battle.Map + ';');
  Writeln(f, #9 + 'StartMetal=' + IntToStr(MetalTracker.Value) + ';');
  Writeln(f, #9 + 'StartEnergy=' + IntToStr(EnergyTracker.Value) + ';');
  Writeln(f, #9 + 'MaxUnits=' + IntToStr(UnitsTracker.Value) + ';');
  Writeln(f, #9 + 'StartPosType=' + IntToStr(StartPosRadioGroup.ItemIndex) + ';');
  Writeln(f, #9 + 'GameMode=' + IntToStr(GameEndRadioGroup.ItemIndex) + ';');
  Writeln(f, #9 + 'GameType=' + ModFileName + ';');
  Writeln(f, '');

  if BattleState.Status = Hosting then
    Writeln(f, #9 + 'hostip=' + 'localhost' + ';')
  else Writeln(f, #9 + 'hostip=' + BattleState.Battle.IP + ';');
  
  Writeln(f, #9 + 'hostport=' + IntToStr(BattleState.Battle.Port) + ';');
  Writeln(f, '');
  Writeln(f, #9 + 'MyPlayerNum=' + IntToStr(BattleState.Battle.Clients.IndexOf(MainForm.GetClient(Status.Username))) + ';');
  Writeln(f, '');
  Writeln(f, #9 + 'NumPlayers=' + IntToStr(BattleState.Battle.Clients.Count) + ';');
  Writeln(f, #9 + 'NumTeams=' + IntToStr(NumberOfTeams) + ';');
  Writeln(f, #9 + 'NumAllyTeams=' + IntToStr(NumberOfAllyTeams) + ';');
  Writeln(f, '');
  // players:
  Pos := 0;
  for i := 0 to BattleState.Battle.Clients.Count-1 do
  begin
    Writeln(f, #9 + '[PLAYER' + IntToStr(i) + ']');
    Writeln(f, #9 + '{');
    Writeln(f, #9 + #9 + 'name=' + TClient(BattleState.Battle.Clients[i]).Name + ';');
    if TClient(BattleState.Battle.Clients[i]).GetMode = 0 then
    begin
      Writeln(f, #9 + #9 + 'Spectator=1;');
      Writeln(f, #9 + '}');
    end
    else
    begin
      Writeln(f, #9 + #9 + 'Spectator=0;');
      Writeln(f, #9 + #9 + 'team=' + IntToStr(PurgedClients[Pos].TeamNo) + ';');
      Writeln(f, #9 + '}');
      Inc(Pos);
    end;
  end;
  Writeln(f, '');
  // teams:
  for i := 0 to NumberOfTeams-1 do
  begin
    Writeln(f, #9 + '[TEAM' + IntToStr(i) + ']');
    Writeln(f, #9 + '{');
    for j := 0 to High(PurgedClients) do if PurgedClients[j].TeamNo = i then
    begin
      Writeln(f, #9 + #9 + 'TeamLeader=' + IntToStr(PurgedClients[j].ClientIndex) + ';');
      Writeln(f, #9 + #9 + 'AllyTeam=' + IntToStr(PurgedClients[j].AllyNo) + ';');
      Writeln(f, #9 + #9 + 'Color=' + IntToStr(PurgedClients[j].TeamColor) + ';');
      if PurgedClients[j].Side = 0 then Writeln(f, #9 + #9 + 'Side=Arm;') else Writeln(f, #9 + #9 + 'Side=Core;');
      Writeln(f, #9 + #9 + 'Handicap=' + IntToStr(PurgedClients[j].Handicap) + ';');
      Break;
    end;
    Writeln(f, #9 + '}');
  end;
  // ally teams:
  for i := 0 to NumberOfAllyTeams-1 do
  begin
    Writeln(f, #9 + '[ALLYTEAM' + IntToStr(i) + ']');
    Writeln(f, #9 + '{');
    Writeln(f, #9 + #9 + 'NumAllies=0;'); // this number is not important
    Writeln(f, #9 + '}');
  end;
  // restrictions:
  Writeln(f, #9 + 'NumRestrictions=' + IntToStr(BattleForm.DisabledUnitsListBox.Items.Count) + ';');
  Writeln(f, #9 + '[RESTRICT]');
  Writeln(f, #9 + '{');
  for i := 0 to BattleForm.DisabledUnitsListBox.Items.Count-1 do
  begin
    Writeln(f, #9 + #9+ 'Unit' + IntToStr(i) + '=' + BattleForm.DisabledUnitsListBox.Items[i] + ';');
    Writeln(f, #9 + #9+ 'Limit' + IntToStr(i) + '=0;');
  end;
  Writeln(f, #9 + '}');


  Finalize(PurgedClients);

  CloseFile(f);
end;

procedure TBattleForm.FormCreate(Sender: TObject);
begin
  InputEdit.Align := alBottom;
  ChatRichEdit.Align := alClient;

  MapImage.Picture.Bitmap.Assign(NoMapImage.Picture.Bitmap);
  PopulateMapList;
  if MapList.Items.Count = 0 then
  begin
    MessageDlg('No maps found! Terminating program ...', mtError, [mbOK], 0);
    Application.Terminate;
    Exit;
  end;

  MapList.ItemIndex := 0;
  MapList.OnClick(MapList); // update selection

  PageControl1.TabIndex := 0;
  ChangeTeamColor(0, False);

  ResetBattleScreen;
end;

procedure TBattleForm.FormDestroy(Sender: TObject);
begin
  BattleState.Battle := nil;
end;

procedure TBattleForm.MapListClick(Sender: TObject);
var
  MapInfo: TMapInfo;
begin
  if MapList.ItemIndex = -1 then Exit; // user does not have the map

  LoadMiniMap(MapList.Items[MapList.ItemIndex], MapImage.Picture.Bitmap);
  MapInfo := AcquireMapInfo(MapList.Items[MapList.ItemIndex]);

  SizeLabel.Caption := 'Size: ' + IntToStr(MapInfo.Width div 64) + ' x ' + IntToStr(MapInfo.Height div 64);

  Label2.Caption := 'Tidal strength: ' + IntToStr(MapInfo.TidalStrength);
  Label3.Caption := 'Gravity: ' + IntToStr(MapInfo.Gravity);
  Label4.Caption := 'Max. metal: ' + Format('%.5g', [MapInfo.Maxmetal]);
  Label5.Caption := 'Extractor radius: ' + IntToStr(MapInfo.ExtractorRadius);
//  Label6.Caption := 'Min. wind: ' + Format('%.5g', [MapInfo.MinWind]);
//  Label7.Caption := 'Max. wind: ' + Format('%.5g', [MapInfo.MaxWind]);
  Label6.Caption := 'Min. wind: ' + IntToStr(MapInfo.MinWind);
  Label7.Caption := 'Max. wind: ' + IntToStr(MapInfo.MaxWind);
  MapDescLabel.Caption := 'Description: ' + MapInfo.Description;
  MapDescLabel.Hint := MapDescLabel.Caption;

  if Sender <> nil then if BattleState.Status = Hosting then // we have to check "Sender <> nil" because we manually trigger this event when server sends new battle info command (with Sender = nil parameter) and we wouldn't want to resend command to server (we would create an endless loop)
    MainForm.TryToSendData('UPDATEBATTLEINFO ' + IntToStr(BattleState.Battle.SpectatorCount) + ' ' + MapList.Items[MapList.ItemIndex]);
end;

procedure TBattleForm.StartButtonClick(Sender: TObject);
begin
  if not IsBattleActive then Exit; // this should not happen

  ReadyCheckBox.Checked := False; // status is automatically updated in OnClick event (which is triggered by changing Checked property, in case if it differs from previous value - which is the case here)

  GenerateScriptFile(ExtractFilePath(Application.ExeName) + 'script.txt');

  FillChar(BattleState.Process.proc_info, sizeof(TProcessInformation), 0);
  FillChar(BattleState.Process.startinfo, sizeof(TStartupInfo), 0);
  BattleState.Process.startinfo.cb := sizeof(TStartupInfo);
  if CreateProcess(nil, 'spring.exe script.txt', nil, nil, false, CREATE_DEFAULT_ERROR_MODE + NORMAL_PRIORITY_CLASS,
                   nil, nil, BattleState.Process.startinfo, BattleState.Process.proc_info) then
  begin
    AddTextToChat('Game launched', Colors.Info);
    MainForm.TryToSendData('MYSTATUS 1');
    GameTimer.Enabled := True;
  end
  else
  begin
    CloseHandle(BattleState.Process.proc_info.hProcess);
    Application.MessageBox('Couldn''t execute the application', 'Error', MB_ICONEXCLAMATION);
  end;
end;

procedure TBattleForm.HostButtonClick(Sender: TObject);
begin
  if not MainForm.AreWeLoggedIn then
  begin
    MessageDlg('You must first log on to the server!', mtWarning, [mbOK], 0);
    Exit;
  end;

  if MapList.ItemIndex = -1 then
  begin
    MapList.ItemIndex := 0; // select first map in a list if none is currently selected
    MapList.OnClick(nil);
  end;
  
  HostBattleForm.ShowModal;
end;

procedure TBattleForm.Label13Click(Sender: TObject);
begin
  ShellExecute(MainForm.Handle, nil, 'http://www.fileuniverse.com/?page=listing&ID=121', '', '', SW_SHOW);
end;

procedure TBattleForm.MapImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MapInfo: TMapInfo;

begin
  if Button <> mbLeft then Exit;
  if MapList.ItemIndex = -1 then Exit; // user does not have this map

  MinimapZoomedForm.Image1.Picture.Bitmap.Assign(MapImage.Picture.Bitmap);
  MapInfo := AcquireMapInfo(MapList.Items[MapList.ItemIndex]);
  MinimapZoomedForm.DrawStartPositions(MapInfo);

  MinimapZoomedForm.Caption := 'Minimap (' + MapList.Items[MapList.ItemIndex] + ')';

  MinimapZoomedForm.ShowModal;
end;

procedure TBattleForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if BattleState.Status = Hosting then
  begin
    DisconnectButton.OnClick(nil);
  end
  else if BattleState.Status = Joined then
  begin
    DisconnectButton.OnClick(nil);
  end;
end;

procedure TBattleForm.DisconnectButtonClick(Sender: TObject);
begin
  if BattleState.Status = None then Exit;

  if BattleState.Status = Joined then
  begin
    MainForm.TryToSendData('LEAVEBATTLE');
    ResetBattleScreen;
  end
  else if BattleState.Status = Hosting then
  begin
    MainForm.TryToSendData('LEAVEBATTLE');
    ResetBattleScreen;
  end;
end;

procedure TBattleForm.ReadyCheckBoxClick(Sender: TObject);
begin
  if not IsBattleActive then Exit;
  SendMyBattleStatusToServer;
  if ReadyCheckBox.Checked then ReadyCheckBox.Font.Color := clGreen else ReadyCheckBox.Font.Color := clRed;
end;

procedure TBattleForm.SideComboBoxChange(Sender: TObject);
begin
  if not IsBattleActive then Exit;
  SendMyBattleStatusToServer;
end;

procedure TBattleForm.TeamComboBoxChange(Sender: TObject);
begin
  if not IsBattleActive then Exit;
  SendMyBattleStatusToServer;
end;

procedure TBattleForm.AllyComboBoxChange(Sender: TObject);
begin
  if not IsBattleActive then Exit;
  SendMyBattleStatusToServer;
end;

procedure TBattleForm.SideComboBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  // this ensures the correct highlite color is used
  (Control as TComboBox).Canvas.FillRect(Rect);

  MainForm.SideImageList.Draw((Control as TComboBox).Canvas, Rect.Left, Rect.Top, Index);
  (Control as TComboBox).Canvas.TextOut(Rect.Left + MainForm.SideImageList.Width + 3, Rect.Top, (Control as TComboBox).Items[Index]);
end;

procedure TBattleForm.SideLabelClick(Sender: TObject);
begin
  SideComboBox.ItemIndex := (SideComboBox.ItemIndex + 1) mod 2;
  SideComboBox.OnChange(nil);
end;

procedure TBattleForm.MetalTrackerMouseUpAfterChange(Sender: TObject);
begin
  SendBattleDetailsToServer;
end;

procedure TBattleForm.EnergyTrackerMouseUpAfterChange(Sender: TObject);
begin
  SendBattleDetailsToServer;
end;

procedure TBattleForm.UnitsTrackerMouseUpAfterChange(Sender: TObject);
begin
  SendBattleDetailsToServer;
end;

procedure TBattleForm.StartPosRadioGroupClick(Sender: TObject);
begin
  SendBattleDetailsToServer;
end;

procedure TBattleForm.ClientsListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Pos: Integer;
  s: string;
  NameSpacing: Integer;
  tmpColor: TColor;
begin
  if not IsBattleActive then
  begin
    UpdateClientsListBox;
    Exit;
  end;

  if Index > BattleState.Battle.Clients.Count-1 then
  begin
    UpdateClientsListBox;
    Exit;
  end;

  // this ensures the correct highlite color is used
  (Control as TListBox).Canvas.FillRect(Rect);

  NameSpacing := 90;
  Pos := 0;

  // side:
  if TClient(BattleState.Battle.Clients[Index]).GetMode = 1 then
    MainForm.SideImageList.Draw((Control as TListBox).Canvas, Rect.Left + Pos, Rect.Top, TClient(BattleState.Battle.Clients[Index]).GetSide);
  Inc(Pos, MainForm.SideImageList.Width + 3);

  // username:
  s := TClient(BattleState.Battle.Clients[Index]).Name;
  if (Control as TListBox).Canvas.TextWidth(s) > NameSpacing then
  begin
    while (Control as TListBox).Canvas.TextWidth(s + '...') > NameSpacing do s := Copy(s, 1, Length(s)-1);
    s := s + '...';
  end;
  (Control as TListBox).Canvas.TextOut(Rect.Left + Pos, Rect.Top, s);
  Inc(Pos, NameSpacing + 5);

  // team and team color:
  if TClient(BattleState.Battle.Clients[Index]).GetMode = 1 then
  begin
    // team color:
    tmpColor := (Control as TListBox).Canvas.Brush.Color;
    (Control as TListBox).Canvas.Brush.Color := TeamColors[TClient(BattleState.Battle.Clients[Index]).GetTeamColor];
    (Control as TListBox).Canvas.Ellipse(Rect.Left + Pos, Rect.Top + 2, Rect.Left + Pos + 10, Rect.Top + 12);
    (Control as TListBox).Canvas.Brush.Color := tmpColor;
    // team no.:
    (Control as TListBox).Canvas.TextOut(Rect.Left + Pos + 13, Rect.Top, IntToStr(TClient(BattleState.Battle.Clients[Index]).GetTeamNo + 1));
  end;
  Inc(Pos, 40);

  // ally:
  if TClient(BattleState.Battle.Clients[Index]).GetMode = 1 then
    (Control as TListBox).Canvas.TextOut(Rect.Left + Pos, Rect.Top, IntToStr(TClient(BattleState.Battle.Clients[Index]).GetAllyNo + 1));
  Inc(Pos, 40);

  // ready:
  if TClient(BattleState.Battle.Clients[Index]).GetMode = 1 then
    MainForm.ReadyStateImageList.Draw((Control as TListBox).Canvas, Rect.Left + Pos, Rect.Top, BoolToInt(TClient(BattleState.Battle.Clients[Index]).GetReadyStatus));
  Inc(Pos, 50);

  // sync:
  MainForm.SyncImageList.Draw((Control as TListBox).Canvas, Rect.Left + Pos, Rect.Top, TClient(BattleState.Battle.Clients[Index]).GetSync);
  Inc(Pos, 55);

  // handicap:
  if TClient(BattleState.Battle.Clients[Index]).GetMode = 1 then
    (Control as TListBox).Canvas.TextOut(Rect.Left + Pos, Rect.Top, IntToStr(TClient(BattleState.Battle.Clients[Index]).GetHandicap));
  Inc(Pos, 20);

end;

{ GameTimer is a timer which we enable when we run spring.exe waiting for it to terminate.
  See also: http://www.latiumsoftware.com/en/delphi/00003.php }
procedure TBattleForm.GameTimerTimer(Sender: TObject);
begin
  GameTimer.Enabled := False;
  if GetExitCodeProcess(BattleState.Process.proc_info.hProcess, BattleState.Process.ExitCode)
  then
    if BattleState.Process.ExitCode = STILL_ACTIVE then
      GameTimer.Enabled := True
    else
    begin
      AddTextToChat('Back from the game', Colors.Info);
      MainForm.TryToSendData('MYSTATUS 0'); // let's tell the server we returned from the game

      CloseHandle(BattleState.Process.proc_info.hProcess);
    end
  else
  begin
    AddTextToChat('Back from the game', Colors.Info);
    MainForm.TryToSendData('MYSTATUS 0'); // let's tell the server we returned from the game

    TerminateProcess(BattleState.Process.proc_info.hProcess, 0);
    CloseHandle(BattleState.Process.proc_info.hProcess);
  end;
end;

procedure TBattleForm.InputEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then Key := #0; // To avoid that annoying noise when pressing #13 key (RETURN/ENTER key)
end;

procedure TBattleForm.InputEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  s: string;
begin
  if Key = 13 then
  begin
    s := (Sender as TEdit).Text;
    (Sender as TEdit).Text := '';
    if s = '' then Exit;
    if (s[1] = '/') or (s[1] = '.') then
    begin
      MainForm.ProcessCommand(Copy(s, 2, Length(s)-1), True);
      Exit;
    end;

    if IsBattleActive then
      MainForm.TryToSendData('SAYBATTLE ' + s);
  end;
end;

procedure TBattleForm.SpectateCheckBoxClick(Sender: TObject);
begin
  if not IsBattleActive then Exit;
  SendMyBattleStatusToServer;
end;

procedure TBattleForm.ClientsListBoxDblClick(Sender: TObject);
var
  i: Integer;
  p: TPoint;
begin
  GetCursorPos(p);
  i := ClientsListBox.ItemAtPos(ClientsListBox.ScreenToClient(p), True);
  if i = -1 then Exit;

  MainForm.OpenPrivateChat(TClient(BattleState.Battle.Clients[i]).Name);
end;


procedure TBattleForm.GameEndRadioGroupClick(Sender: TObject);
begin
  SendBattleDetailsToServer;
end;

procedure TBattleForm.HandicapTrackerMouseUpAfterChange(Sender: TObject);
begin
  if (IsBattleActive) and (BattleState.Status = Hosting) and (ClientsListBox.ItemIndex <> -1) and (ClientsListBox.ItemIndex <= BattleState.Battle.Clients.Count-1) then
  begin
    MainForm.TryToSendData('HANDICAP ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name + ' ' + IntToStr(HandicapTracker.Value));
  end;
end;

procedure TBattleForm.ClientsListBoxClick(Sender: TObject);
begin
  if (BattleState.Status = Hosting) and (ClientsListBox.ItemIndex <> -1)
  and (ClientsListBox.ItemIndex <= BattleState.Battle.Clients.Count-1)
  and (TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).GetMode = 1) then
  begin
    HandicapTracker.Value := TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).GetHandicap;
    ForceTeamComboBox.ItemIndex := TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).GetTeamNo;
    ForceAllyComboBox.ItemIndex := TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).GetAllyNo;
    EnableControlAndChildren(PlayerControlGroupBox);
  end;
end;

{ if UpdateServer=True, then we notify server about new team color }
procedure TBattleForm.ChangeTeamColor(ColorIndex: Integer; UpdateServer: Boolean);
begin
  with TeamColorSpeedButton.Glyph.Canvas do
  begin
    Pen.Color := TeamColors[TeamColorIndex];
    Brush.Color := TeamColors[TeamColorIndex];
    Rectangle(0+1, 0+1, TeamColorSpeedButton.Glyph.Width-2, TeamColorSpeedButton.Glyph.Height-2);
  end;

  TeamColorIndex := ColorIndex;

  if UpdateServer then SendMyBattleStatusToServer;
end;


procedure TBattleForm.TeamColorSpeedButtonClick(Sender: TObject);
begin
  if not (ChooseColorForm.ShowModal = mrOK) then Exit;
  ChangeTeamColor(TeamColorIndex, True);
end;

procedure TBattleForm.SpeedButton1Click(Sender: TObject);
begin
  if (IsBattleActive) and (BattleState.Status = Hosting) and (ClientsListBox.ItemIndex <> -1) and (ClientsListBox.ItemIndex <= BattleState.Battle.Clients.Count-1) then
  begin
    MainForm.TryToSendData('KICKFROMBATTLE ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name);
  end;
end;

procedure TBattleForm.ForceTeamComboBoxClick(Sender: TObject);
begin
  MainForm.TryToSendData('FORCETEAMNO ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name + ' ' + IntToStr(ForceTeamComboBox.ItemIndex));
  AddTextToChat('Forcing ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name + '''s team number ...', Colors.Info);
end;

procedure TBattleForm.ForceAllyComboBoxClick(Sender: TObject);
begin
  MainForm.TryToSendData('FORCEALLYNO ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name + ' ' + IntToStr(ForceAllyComboBox.ItemIndex));
  AddTextToChat('Forcing ' + TClient(BattleState.Battle.Clients[ClientsListBox.ItemIndex]).Name + '''s ally number ...', Colors.Info);
end;

procedure TBattleForm.AddUnitsSpeedButtonClick(Sender: TObject);
var
  i: Integer;
  node: PVirtualNode;
  s: string;
begin
  if DisableUnitsForm.ShowModal <> mrOK then Exit;
  DisabledUnitsListBox.Clear;

  i := 0;
  node := DisableUnitsForm.VDTUnits.GetFirst;
  while node <> nil do
  begin
    if (node.CheckState = csCheckedNormal) or (node.CheckState = csCheckedPressed) then
      DisabledUnitsListBox.Items.Add(UnitList[i]);

    node := node.NextSibling;
    Inc(i);
  end;

  // for the sake of simplicity we send the entire list each time it is changed
  // (we could also generate diff list and update it with ENABLEUNITS/DISABLEUNITS commands)
  MainForm.TryToSendData('ENABLEALLUNITS');
  if DisabledUnitsListBox.Items.Count > 0 then
  begin
    s := 'DISABLEUNITS';
    for i := 0 to DisabledUnitsListBox.Items.Count-1 do
      s := s + ' ' + DisabledUnitsListBox.Items[i];
    MainForm.TryToSendData(s);
  end;
end;

procedure TBattleForm.Item1Click(Sender: TObject);
var
  i: Integer;
begin

  if BattleState.Status = Hosting then
  begin
    Utility.ReInitLib;
    Utility.GetMapList(MapList.Items);
    MapList.ItemIndex := 0;
    MapList.OnClick(MapList); // to update selection
  end
  else if BattleState.Status = Joined then
  begin
    Utility.ReInitLib;
    Utility.GetMapList(MapList.Items);

    i := BattleForm.MapList.Items.IndexOf(BattleState.Battle.Map);
    if i = -1 then ChangeMapToNoMap(BattleState.Battle.Map)
    else
    begin
      BattleForm.MapList.ItemIndex := i;
      BattleForm.MapList.OnClick(nil); // we MUST send nil as parameter .. see MapList.OnClick event implementation
    end;
  end
  else
  begin // just reinit and reload
    Utility.ReInitLib;
    Utility.GetMapList(MapList.Items);
  end;
end;

end.
