using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Net;
using Microsoft.Win32;

namespace SpringClient
{
	/// <summary>
	/// Summary description for Configuration.
	/// </summary>
	public class Configuration : System.Windows.Forms.Form
	{
		private System.Windows.Forms.CheckBox checkBoxIPOverride;
		private System.Windows.Forms.TextBox IPOverride;
		private System.Windows.Forms.ErrorProvider errorProvider1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;

		static bool Check = false;
		static string IP = "";

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Configuration()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			checkBoxIPOverride.Checked = Check;
			if ( !Check )
			{
				checkBoxIPOverride.Checked = false;
			}
			else
			{
				checkBoxIPOverride.Checked = true;
				IPOverride.Text = IP;
			}
		}

		static public void GetConfiguration()
		{
			try
			{
				RegistryKey rk = Registry.LocalMachine.CreateSubKey(@"Software\SY\SpringClient");
				
				if ( rk.GetValue("IPOverride") == null )
				{
					Check = false;
				}
				else
				{
					string address = (string)rk.GetValue("IPOverride");
					Check = true;
					IPAddress ip = IPAddress.Parse(address);
					IP = ip.ToString();
					Global.connMan.Send((byte)PACKETS.PACK_IPOVERRIDE);
					Global.connMan.Send(ip.GetAddressBytes());
				}
				rk.Close();
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
				// if there's an error, get rid of the reg key
				RegistryKey rk = Registry.LocalMachine.CreateSubKey(@"Software\SY\SpringClient");
				
				if ( rk.GetValue("IPOverride") != null )
				{
					rk.DeleteValue("IPOverride");
				}
				rk.Close();
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Configuration));
			this.checkBoxIPOverride = new System.Windows.Forms.CheckBox();
			this.IPOverride = new System.Windows.Forms.TextBox();
			this.errorProvider1 = new System.Windows.Forms.ErrorProvider();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// checkBoxIPOverride
			// 
			this.checkBoxIPOverride.Location = new System.Drawing.Point(24, 16);
			this.checkBoxIPOverride.Name = "checkBoxIPOverride";
			this.checkBoxIPOverride.Size = new System.Drawing.Size(240, 24);
			this.checkBoxIPOverride.TabIndex = 0;
			this.checkBoxIPOverride.Text = "Click to input your  IP address manually";
			this.checkBoxIPOverride.CheckedChanged += new System.EventHandler(this.checkBoxIPOverride_CheckedChanged);
			// 
			// IPOverride
			// 
			this.IPOverride.Enabled = false;
			this.IPOverride.Location = new System.Drawing.Point(40, 40);
			this.IPOverride.Name = "IPOverride";
			this.IPOverride.Size = new System.Drawing.Size(144, 20);
			this.IPOverride.TabIndex = 1;
			this.IPOverride.Text = "";
			// 
			// errorProvider1
			// 
			this.errorProvider1.ContainerControl = this;
			// 
			// button1
			// 
			this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.button1.Location = new System.Drawing.Point(48, 88);
			this.button1.Name = "button1";
			this.button1.TabIndex = 2;
			this.button1.Text = "Ok";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.button2.Location = new System.Drawing.Point(160, 88);
			this.button2.Name = "button2";
			this.button2.TabIndex = 3;
			this.button2.Text = "Cancel";
			// 
			// Configuration
			// 
			this.AcceptButton = this.button1;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.button2;
			this.ClientSize = new System.Drawing.Size(288, 142);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.IPOverride);
			this.Controls.Add(this.checkBoxIPOverride);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Configuration";
			this.Text = "Configuration";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			if ( checkBoxIPOverride.Checked )
			{
				if ( !ValidateIPOverride() )
				{
					return;
				}
				IPAddress ip = IPAddress.Parse(IPOverride.Text);
				RegistryKey rk = Registry.LocalMachine.CreateSubKey(@"Software\SY\SpringClient");
				rk.SetValue("IPOverride", IPOverride.Text);
				rk.Close();
				Check = true;
				IP = IPOverride.Text;
				Global.connMan.Send((byte)PACKETS.PACK_IPOVERRIDE);
				Global.connMan.Send(ip.GetAddressBytes());
			}
			else
			{
				RegistryKey rk = Registry.LocalMachine.OpenSubKey(@"Software\SY\SpringClient", true);
				if ( rk != null )
				{
					rk.DeleteValue("IPOverride", false);
					rk.Close();
				}
				Check = false;
				IP = "";
				Global.connMan.Send((byte)PACKETS.PACK_IPOVERRIDE);
				Global.connMan.Send((int)0);
			}
		}

		private bool ValidateIPOverride()
		{
			try
			{
				if ( IPOverride.Text.Length == 0 )
				{
					errorProvider1.SetError(IPOverride, "Box cannot be empty");
					return false;
				}
				string regex = @"\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b";
				if ( Regex.Match(IPOverride.Text, regex, RegexOptions.None).Value != IPOverride.Text )
				{
					errorProvider1.SetError(IPOverride, "Not a valid IP address");
					return false;
				}
				errorProvider1.SetError(IPOverride, null);
				return true;
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
				return false;
			}
		}

		private void checkBoxIPOverride_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( checkBoxIPOverride.Checked )
			{
				IPOverride.Enabled = true;
			}
			else
			{
				IPOverride.Enabled = false;
			}
		}
	}
}
