using System;
using System.Threading;

namespace SpringClient
{
	public class Global
	{
		static public string ServerLoc = "taserver.phoenixworx.org";//"localhost";
		static public int ServerPort = 4897;
		static public ConnectionManager connMan = null;
		static public BattleRoom battleRoom = null;
		static public ClientMain PrimaryForm = null;
		static public string SpringDirectory = @".";
		static public int DefaultBattlePort = 8452;
		static public int DefaultMaxUnits = 500;
		static public int DefaultMaxEnergy = 1000;
		static public int DefaultMaxMetal = 1000;
		static public string BattleRoomPassword = "";
		static public string SelectedMod;
//		static public Thread	TBattle = null;
	}

	public enum PACKETS : byte
	{
		PACK_LOGIN				=1,
		PACK_CHATMESSAGE		=2,
		PACK_REQJOINCHAT		=3,
		PACK_CHATLIST			=4,
		PACK_BOOTFROMCHAT		=5,
		PACK_KILLCHAT			=6,
		PACK_KICKEDFROMCHAT		=7,
		PACK_LOGGEDIN			=8,
		PACK_LOGINFAILED		=9,
		PACK_BLOCKED			=10,
		PACK_JOINCHAT			=11,
		PACK_LEAVECHAT			=12,
		PACK_USERENTERCHAT		=13,
		PACK_USERLEAVECHAT		=14,
		PACK_REGISTER			=15,
		PACK_JOINBATTLE			=16,
		PACK_LEAVEBATTLE		=17,
		PACK_USERENTERBATTLE	=18,
		PACK_USERLEAVEBATTLE	=19,
		PACK_REQJOINBATTLE		=20,
		PACK_BATTLEMESSAGE		=21,
		PACK_BATTLELIST			=22,
		PACK_BOOTFROMBATTLE		=23,
		PACK_CREATECHAT			=24,
		PACK_CREATEBATTLE		=25,
		PACK_KICKEDFROMBATTLE	=26,
		PACK_DESTROYBATTLE		=27,
		PACK_CHATCREATESUCCESS	=28,
		PACK_FAILEDCREATECHAT	=29,
		PACK_CHATDESTROYED		=30,
		PACK_BATTLECREATESUCCESS =31,
		PACK_BATTLECREATEFAILED	=32,
		PACK_BATTLELOGGEDIN		=33,
		PACK_INTERNALBATTLELIST =34,
		PACK_REGISTERSUCCESS	=35,
		PACK_REGISTERFAILED		=36,
		PACK_KEEPALIVE			=37,
		PACK_IPOVERRIDE			=38,
		PACK_CHATSIZEUPDATE		=39,
		PACK_BATTLELOGINFAILED	=40,
		PACK_BATTLESIZEUPDATE	=41,
		PACK_MAPUPDATE			=42,
		PACK_BATTLEPROGRESS		=43,
		PACK_BATTLETEST			=44
	}

	public enum BATTLEPACK
	{
		PACK_MESSAGE			=1,
		PACK_LIST				=2,
		PACK_CHANGETEAM			=3,
		PACK_CHANGEALLYTEAM		=4,
		PACK_LEAVE				=5,
		PACK_KEEPALIVE			=6,
		PACK_READY				=7,
		PACK_START				=8,
		PACK_MAP				=9,
		PACK_NEWUSER			=10,
		PACK_ALLIANCE			=11,
		PACK_CHANGESIDE			=12,
		PACK_REMOVEALLIANCE		=13,
		PACK_CHANGERESOURCES	=14,
		PACK_CHANGEMAXUNITS		=15,
		PACK_CHANGESTARTPOSTYPE	=16,
		PACK_BOOTED				=17,
		PACK_SYNCLIST			=18,
		PACK_SYNCED				=19,
		PACK_CHANGEGAMEGOALTYPE	=20
}

	public enum PACKASSIST
	{
		REGISTER_USEREXISTS		=1,
		REGISTER_BADUSERNAME	=2,
		REGISTER_FORMATMISMATCH	=3,
		REGISTER_BADPASSWORD	=4,
		REGISTER_GENERIC		=5
	}

	public enum LOGINERROR
	{
		LOGINERROR_VERSION		=1,
		LOGINERROR_USER			=2,
		LOGINERROR_PASSWORD		=3
	}

	public struct CONSTANTS
	{
		static public int MAXCLAN = 10;
		static public int MAXNAME = 20;
		static public int MAXPASSWD	= 30;
		static public int MAXMAPNAME = 32;
		static public int MAXCHATNAME	= 20;
		static public int MAXBATTLENAME	= 50;
		static public int MAXMESSAGELEN	= 256;
		static public byte VERMAJOR = 1;
		static public byte VERMINOR = 0;
	};

	public struct Win32
	{
		static public int SB_BOTTOM = 7;
		static public int WM_VSCROLL = 0x115;
		static public int SB_VERT = 1;
	};
}